/*
 * Copyright (c) 2000 Blue Mug, Inc.  All Rights Reserved.
 */

#ifndef _HERMIT_CONFIG_H
#define _HERMIT_CONFIG_H

#include "ttype.h"

typedef enum command_type {
	CMD_INVALID = 0,
	CMD_DOWNLOAD,
	CMD_HELP,
	CMD_MAP,
	CMD_TERMINAL,
	CMD_UPLOAD,
} command_type_t;

typedef struct download_command_info download_command_info_t;
struct download_command_info {
	int have_address;
};

typedef struct command command_t;
struct command {
	command_type_t type;
	char *input_path;
	char *output_path;
	char *region;
	taddr_t addr;
	tsize_t size;
	union info_u {
		download_command_info_t download;
	} info;
	command_t *next;
};

extern const char *command_name(const command_t *command);
extern void print_command(const command_t *command);
extern command_t *get_commands(int argc, char *argv[]);
extern void usage_and_exit(void) __attribute__ ((noreturn));

/* making functions for these would be too much work */
extern int opt_anon_regions;
extern int opt_ethernet;
extern int opt_force_locked;
extern int opt_terminal;
extern int opt_verbose;

extern const char *opt_memory_map_path;
extern const char *opt_netif;
extern const char *opt_port;
extern const char *opt_remote_mac;
extern unsigned char opt_remote_mac_bytes[];

#endif /* _HERMIT_CONFIG_H */
